#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/select.h>
#include <sys/socket.h>
#include <sys/un.h>

#include "config.h"
#include "cgi.h"
#include "portaloo.h"
#include "md5.h"
#include "web_tty.h"


static void write_html(int fd)
{
	char *x;
	
	x=cgi_find("command");
	if(x && *x)
	{
		if(write(fd, x, strlen(x))!=strlen(x))
		{
			printf("Content-type: text/plain\n\nSocket error\n");
			exit(1);
		}

		write(fd, "\n", 1);
	}
	printf("Content-Type: text/html\n\n");
	printf("<HEAD>\n");
	printf("</HEAD>\n");
	printf("<BODY bgcolor=\"#eeeebb\">\n");
	printf("<FONT face=\"helvetica\">\n");
	printf("<FORM name=\"fred\" action=\""WEB_TTY_CGI"\" method=\"get\">\n");
	printf("<INPUT type=text name=command size=65 maxlength=255>\n");
	printf("</FORM>\n");
	printf("</FONT>\n");
	printf("<SCRIPT>\n");
	printf("document.fred.command.focus()\n");
	printf("</SCRIPT>\n");
	printf("</BODY>\n");
}

int main(int argc, char *argv[])
{
	int fd=socket(PF_UNIX, SOCK_STREAM, 0);
	struct sockaddr_un sun;
	char *p;
	
	cgi_process();
	if(load_secret()<0)
	{
		printf("Content-type:text/plain\n\nNo/bad secret.\n");
		exit(1);
	}
	
	p=getenv("HTTP_COOKIE");
	if(p==NULL)
	{
		init_portaloo(&self, "unset");
	}
	else
	{
		switch(decode_portaloo_cookie(&self, p))
		{
			case -1:
			case 0:
				init_portaloo(&self, "broken");
				break;
			default:
				if(strcmp(self.uname, "broken")==0)
					strcpy(self.uname, "unset-ok");
		}
	}

	if(!(self.flags[0]&FLAGS0_NAME_SET))
	{
		/* Do an error here */
		/* FIXME */
		printf("Content-type:text/plain\n\nNo login no play.\n");
		exit(1);
	}
	if(fd==-1)
	{
		perror("socket");
		exit(1);
	}
	
	sun.sun_family=AF_UNIX;
	snprintf(sun.sun_path, sizeof(sun.sun_path), WEB_TTY_PATH, self.uname,
		self.flags[1]);
	
	if(connect(fd, (struct sockaddr *)&sun, sizeof(sun))==-1)
	{
		printf("Content-type: text/plain\n\nSocket error %s\n", sun.sun_path);
		exit(1);
	}
			
	if(argv[1])
	{
		write(fd, argv[1], strlen(argv[1]));
		write(fd, "\n", 1);
	}
	else
	{
		write_html(fd);
	}
	close(fd);
	return 0;
}
